#ifndef NPSTAT_LONGERTYPE_HH_
#define NPSTAT_LONGERTYPE_HH_

/*!
// \file LongerType.hh
//
// \brief Compile-time deduction of an appropriate numeric type for
//        simple algebraic operations
//
// Author: I. Volobouev
//
// September 2019
*/

#include <type_traits>

namespace npstat {
    template <class T1, class T2>
    struct LongerType
    {
        typedef typename std::common_type<T1,T2>::type type;
    };

    template <class T1>
    struct LongerType<T1,T1>
    {
        typedef T1 type;
    };

    template<unsigned I1, unsigned I2>
    struct BiggerUInt
    {
        enum {value = I1 > I2 ? I1 : I2};
    };
}

#endif // NPSTAT_LONGERTYPE_HH_
